/* GNU Prolog interface: GNU Prolog part.
   Copyright (C) 2001-2010 Roberto Bagnara <bagnara@cs.unipr.it>
   Copyright (C) 2010-2016 BUGSENG srl (http://bugseng.com)

This file is part of the Parma Polyhedra Library (PPL).

The PPL is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The PPL is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02111-1307, USA.

For the most up-to-date information see the Parma Polyhedra Library
site: http://bugseng.com/products/ppl/ . 
*/
:- foreign(ppl_version_major(+term)).
:- foreign(ppl_version_minor(+term)).
:- foreign(ppl_version_revision(+term)).
:- foreign(ppl_version_beta(+term)).
:- foreign(ppl_version(+term)).
:- foreign(ppl_banner(+term)).
:- foreign(ppl_max_space_dimension(+term)).
:- foreign(ppl_Coefficient_bits(+term)).
:- foreign(ppl_Coefficient_is_bounded).
:- foreign(ppl_Coefficient_max(+term)).
:- foreign(ppl_Coefficient_min(+term)).
:- foreign(ppl_initialize).
:- foreign(ppl_finalize).
:- foreign(ppl_set_rounding_for_PPL).
:- foreign(ppl_restore_pre_PPL_rounding).
:- foreign(ppl_irrational_precision(+term)).
:- foreign(ppl_set_irrational_precision(+term)).
:- foreign(ppl_set_timeout_exception_atom(+term)).
:- foreign(ppl_timeout_exception_atom(+term)).
:- foreign(ppl_set_timeout(+term)).
:- foreign(ppl_reset_timeout).
:- foreign(ppl_set_deterministic_timeout(+term, +term)).
:- foreign(ppl_reset_deterministic_timeout).
:- foreign(ppl_new_MIP_Problem_from_space_dimension(+term, +term)).
:- foreign(ppl_new_MIP_Problem(+term, +term, +term, +term, +term)).
:- foreign(ppl_new_MIP_Problem_from_MIP_Problem(+term, +term)).
:- foreign(ppl_MIP_Problem_swap(+term, +term)).
:- foreign(ppl_delete_MIP_Problem(+term)).
:- foreign(ppl_MIP_Problem_space_dimension(+term, +term)).
:- foreign(ppl_MIP_Problem_integer_space_dimensions(+term, +term)).
:- foreign(ppl_MIP_Problem_constraints(+term, +term)).
:- foreign(ppl_MIP_Problem_objective_function(+term, +term)).
:- foreign(ppl_MIP_Problem_optimization_mode(+term, +term)).
:- foreign(ppl_MIP_Problem_clear(+term)).
:- foreign(ppl_MIP_Problem_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_MIP_Problem_add_to_integer_space_dimensions(+term, +term)).
:- foreign(ppl_MIP_Problem_add_constraint(+term, +term)).
:- foreign(ppl_MIP_Problem_add_constraints(+term, +term)).
:- foreign(ppl_MIP_Problem_set_objective_function(+term, +term)).
:- foreign(ppl_MIP_Problem_set_optimization_mode(+term, +term)).
:- foreign(ppl_MIP_Problem_set_control_parameter(+term, +term)).
:- foreign(ppl_MIP_Problem_get_control_parameter(+term, +term, +term)).
:- foreign(ppl_MIP_Problem_is_satisfiable(+term)).
:- foreign(ppl_MIP_Problem_solve(+term, +term)).
:- foreign(ppl_MIP_Problem_feasible_point(+term, +term)).
:- foreign(ppl_MIP_Problem_optimizing_point(+term, +term)).
:- foreign(ppl_MIP_Problem_optimal_value(+term, +term, +term)).
:- foreign(ppl_MIP_Problem_evaluate_objective_function(+term, +term, +term, +term)).
:- foreign(ppl_MIP_Problem_OK(+term)).

:- foreign(ppl_MIP_Problem_ascii_dump(+term)).
:- foreign(ppl_new_PIP_Problem_from_space_dimension(+term, +term)).
:- foreign(ppl_new_PIP_Problem(+term, +term, +term, +term)).
:- foreign(ppl_new_PIP_Problem_from_PIP_Problem(+term, +term)).
:- foreign(ppl_PIP_Problem_swap(+term, +term)).
:- foreign(ppl_delete_PIP_Problem(+term)).
:- foreign(ppl_PIP_Problem_space_dimension(+term, +term)).
:- foreign(ppl_PIP_Problem_parameter_space_dimensions(+term, +term)).
:- foreign(ppl_PIP_Problem_constraints(+term, +term)).
:- foreign(ppl_PIP_Problem_clear(+term)).
:- foreign(ppl_PIP_Problem_add_space_dimensions_and_embed(+term, +term, +term)).
:- foreign(ppl_PIP_Problem_add_to_parameter_space_dimensions(+term, +term)).
:- foreign(ppl_PIP_Problem_add_constraint(+term, +term)).
:- foreign(ppl_PIP_Problem_add_constraints(+term, +term)).
:- foreign(ppl_PIP_Problem_set_control_parameter(+term, +term)).
:- foreign(ppl_PIP_Problem_get_control_parameter(+term, +term, +term)).
:- foreign(ppl_PIP_Problem_has_big_parameter_dimension(+term, +term)).
:- foreign(ppl_PIP_Problem_set_big_parameter_dimension(+term, +term)).
:- foreign(ppl_PIP_Problem_is_satisfiable(+term)).
:- foreign(ppl_PIP_Problem_solve(+term, +term)).
:- foreign(ppl_PIP_Problem_solution(+term, +term)).
:- foreign(ppl_PIP_Problem_optimizing_solution(+term, +term)).
:- foreign(ppl_PIP_Problem_OK(+term)).
:- foreign(ppl_PIP_Problem_ascii_dump(+term)).
:- foreign(ppl_PIP_Tree_Node_constraints(+term, +term)).
:- foreign(ppl_PIP_Tree_Node_is_solution(+term)).
:- foreign(ppl_PIP_Tree_Node_is_decision(+term)).
:- foreign(ppl_PIP_Tree_Node_is_bottom(+term)).
:- foreign(ppl_PIP_Tree_Node_artificials(+term, +term)).
:- foreign(ppl_PIP_Tree_Node_OK(+term)).
:- foreign(ppl_PIP_Tree_Node_parametric_values(+term, +term, +term)).
:- foreign(ppl_PIP_Tree_Node_true_child(+term, +term)).
:- foreign(ppl_PIP_Tree_Node_false_child(+term, +term)).
:- foreign(ppl_delete_Polyhedron(+term)).



:- foreign(ppl_new_C_Polyhedron_from_space_dimension(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_C_Polyhedron_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Grid(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Grid(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Double_Box(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Double_Box(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Octagonal_Shape_double(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_C_Polyhedron_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_C_Polyhedron_from_constraints(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_constraints(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_congruences(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_congruences(+term, +term)).
:- foreign(ppl_new_C_Polyhedron_from_generators(+term, +term)).
:- foreign(ppl_new_NNC_Polyhedron_from_generators(+term, +term)).





:- foreign(ppl_Polyhedron_swap(+term, +term)).



:- foreign(ppl_Polyhedron_space_dimension(+term, +term)).
:- foreign(ppl_Polyhedron_affine_dimension(+term, +term)).




:- foreign(ppl_Polyhedron_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Polyhedron_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Polyhedron_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_Polyhedron_get_constraints(+term, +term)).
:- foreign(ppl_Polyhedron_get_congruences(+term, +term)).
:- foreign(ppl_Polyhedron_get_generators(+term, +term)).




:- foreign(ppl_Polyhedron_get_minimized_constraints(+term, +term)).
:- foreign(ppl_Polyhedron_get_minimized_congruences(+term, +term)).
:- foreign(ppl_Polyhedron_get_minimized_generators(+term, +term)).




:- foreign(ppl_Polyhedron_is_empty(+term)).
:- foreign(ppl_Polyhedron_is_universe(+term)).
:- foreign(ppl_Polyhedron_is_bounded(+term)).
:- foreign(ppl_Polyhedron_contains_integer_point(+term)).
:- foreign(ppl_Polyhedron_is_topologically_closed(+term)).
:- foreign(ppl_Polyhedron_is_discrete(+term)).




:- foreign(ppl_Polyhedron_topological_closure_assign(+term)).




:- foreign(ppl_Polyhedron_bounds_from_above(+term, +term)).
:- foreign(ppl_Polyhedron_bounds_from_below(+term, +term)).




:- foreign(ppl_Polyhedron_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Polyhedron_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Polyhedron_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_Polyhedron_contains_Polyhedron(+term, +term)).
:- foreign(ppl_Polyhedron_strictly_contains_Polyhedron(+term, +term)).
:- foreign(ppl_Polyhedron_is_disjoint_from_Polyhedron(+term, +term)).




:- foreign(ppl_Polyhedron_equals_Polyhedron(+term, +term)).



:- foreign(ppl_Polyhedron_OK(+term)).



:- foreign(ppl_Polyhedron_add_constraint(+term, +term)).
:- foreign(ppl_Polyhedron_add_congruence(+term, +term)).
:- foreign(ppl_Polyhedron_add_generator(+term, +term)).




:- foreign(ppl_Polyhedron_add_constraints(+term, +term)).
:- foreign(ppl_Polyhedron_add_congruences(+term, +term)).
:- foreign(ppl_Polyhedron_add_generators(+term, +term)).




:- foreign(ppl_Polyhedron_refine_with_constraint(+term, +term)).
:- foreign(ppl_Polyhedron_refine_with_congruence(+term, +term)).




:- foreign(ppl_Polyhedron_refine_with_constraints(+term, +term)).
:- foreign(ppl_Polyhedron_refine_with_congruences(+term, +term)).




:- foreign(ppl_Polyhedron_intersection_assign(+term, +term)).
:- foreign(ppl_Polyhedron_upper_bound_assign(+term, +term)).
:- foreign(ppl_Polyhedron_difference_assign(+term, +term)).
:- foreign(ppl_Polyhedron_concatenate_assign(+term, +term)).
:- foreign(ppl_Polyhedron_time_elapse_assign(+term, +term)).
:- foreign(ppl_Polyhedron_poly_hull_assign(+term, +term)).
:- foreign(ppl_Polyhedron_poly_difference_assign(+term, +term)).




:- foreign(ppl_Polyhedron_upper_bound_assign_if_exact(+term, +term)).
:- foreign(ppl_Polyhedron_poly_hull_assign_if_exact(+term, +term)).




:- foreign(ppl_Polyhedron_positive_time_elapse_assign(+term, +term)).



:- foreign(ppl_Polyhedron_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_Polyhedron_constrains(+term, +term)).



:- foreign(ppl_Polyhedron_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Polyhedron_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Polyhedron_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Polyhedron_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Polyhedron_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Polyhedron_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Polyhedron_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Polyhedron_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Polyhedron_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Polyhedron_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Polyhedron_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Polyhedron_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Polyhedron_map_space_dimensions(+term, +term)).



:- foreign(ppl_Polyhedron_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Polyhedron_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Polyhedron_ascii_dump(+term)).



:- foreign(ppl_Polyhedron_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Polyhedron_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_Polyhedron_BHRZ03_widening_assign_with_tokens(+term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_H79_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Polyhedron_BHRZ03_widening_assign(+term, +term)).
:- foreign(ppl_Polyhedron_H79_widening_assign(+term, +term)).




:- foreign(ppl_Polyhedron_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_Polyhedron_widening_assign(+term, +term)).



:- foreign(ppl_Polyhedron_limited_BHRZ03_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_bounded_BHRZ03_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_limited_H79_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_Polyhedron_bounded_H79_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_Polyhedron_limited_BHRZ03_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_Polyhedron_bounded_BHRZ03_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_Polyhedron_limited_H79_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_Polyhedron_bounded_H79_extrapolation_assign(+term, +term, +term)).









:- foreign(ppl_Polyhedron_linear_partition(+term, +term, +term, +term)).




:- foreign(ppl_Polyhedron_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_C_Polyhedron(+term)).
:- foreign(ppl_termination_test_PR_C_Polyhedron(+term)).
:- foreign(ppl_termination_test_MS_NNC_Polyhedron(+term)).
:- foreign(ppl_termination_test_PR_NNC_Polyhedron(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_C_Polyhedron(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_C_Polyhedron(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_MS_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_NNC_Polyhedron(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_C_Polyhedron(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_C_Polyhedron(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_MS_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_NNC_Polyhedron(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_C_Polyhedron(+term, +term, +term)).
:- foreign(ppl_all_affine_quasi_ranking_functions_MS_NNC_Polyhedron(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_C_Polyhedron_2(+term, +term)).
:- foreign(ppl_termination_test_PR_C_Polyhedron_2(+term, +term)).
:- foreign(ppl_termination_test_MS_NNC_Polyhedron_2(+term, +term)).
:- foreign(ppl_termination_test_PR_NNC_Polyhedron_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_C_Polyhedron_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_C_Polyhedron_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_MS_NNC_Polyhedron_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_NNC_Polyhedron_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_C_Polyhedron_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_C_Polyhedron_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_MS_NNC_Polyhedron_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_NNC_Polyhedron_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_C_Polyhedron_2(+term, +term, +term, +term)).
:- foreign(ppl_all_affine_quasi_ranking_functions_MS_NNC_Polyhedron_2(+term, +term, +term, +term)).





:- foreign(ppl_delete_Grid(+term)).



:- foreign(ppl_new_Grid_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_Grid_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_Grid_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_Grid_from_Grid(+term, +term)).
:- foreign(ppl_new_Grid_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_Grid_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Grid_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Grid_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Grid_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Grid_from_Double_Box(+term, +term)).
:- foreign(ppl_new_Grid_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_Grid_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_Grid_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Grid_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_Grid_from_constraints(+term, +term)).
:- foreign(ppl_new_Grid_from_congruences(+term, +term)).
:- foreign(ppl_new_Grid_from_grid_generators(+term, +term)).





:- foreign(ppl_Grid_swap(+term, +term)).



:- foreign(ppl_Grid_space_dimension(+term, +term)).
:- foreign(ppl_Grid_affine_dimension(+term, +term)).




:- foreign(ppl_Grid_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Grid_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Grid_relation_with_congruence(+term, +term, +term)).
:- foreign(ppl_Grid_relation_with_grid_generator(+term, +term, +term)).




:- foreign(ppl_Grid_get_constraints(+term, +term)).
:- foreign(ppl_Grid_get_congruences(+term, +term)).
:- foreign(ppl_Grid_get_grid_generators(+term, +term)).




:- foreign(ppl_Grid_get_minimized_constraints(+term, +term)).
:- foreign(ppl_Grid_get_minimized_congruences(+term, +term)).
:- foreign(ppl_Grid_get_minimized_grid_generators(+term, +term)).




:- foreign(ppl_Grid_is_empty(+term)).
:- foreign(ppl_Grid_is_universe(+term)).
:- foreign(ppl_Grid_is_bounded(+term)).
:- foreign(ppl_Grid_contains_integer_point(+term)).
:- foreign(ppl_Grid_is_topologically_closed(+term)).
:- foreign(ppl_Grid_is_discrete(+term)).




:- foreign(ppl_Grid_topological_closure_assign(+term)).




:- foreign(ppl_Grid_bounds_from_above(+term, +term)).
:- foreign(ppl_Grid_bounds_from_below(+term, +term)).




:- foreign(ppl_Grid_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Grid_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Grid_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Grid_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Grid_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_Grid_contains_Grid(+term, +term)).
:- foreign(ppl_Grid_strictly_contains_Grid(+term, +term)).
:- foreign(ppl_Grid_is_disjoint_from_Grid(+term, +term)).




:- foreign(ppl_Grid_equals_Grid(+term, +term)).



:- foreign(ppl_Grid_OK(+term)).



:- foreign(ppl_Grid_add_constraint(+term, +term)).
:- foreign(ppl_Grid_add_congruence(+term, +term)).
:- foreign(ppl_Grid_add_grid_generator(+term, +term)).




:- foreign(ppl_Grid_add_constraints(+term, +term)).
:- foreign(ppl_Grid_add_congruences(+term, +term)).
:- foreign(ppl_Grid_add_grid_generators(+term, +term)).




:- foreign(ppl_Grid_refine_with_constraint(+term, +term)).
:- foreign(ppl_Grid_refine_with_congruence(+term, +term)).




:- foreign(ppl_Grid_refine_with_constraints(+term, +term)).
:- foreign(ppl_Grid_refine_with_congruences(+term, +term)).




:- foreign(ppl_Grid_intersection_assign(+term, +term)).
:- foreign(ppl_Grid_upper_bound_assign(+term, +term)).
:- foreign(ppl_Grid_difference_assign(+term, +term)).
:- foreign(ppl_Grid_concatenate_assign(+term, +term)).
:- foreign(ppl_Grid_time_elapse_assign(+term, +term)).




:- foreign(ppl_Grid_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_Grid_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_Grid_constrains(+term, +term)).



:- foreign(ppl_Grid_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Grid_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Grid_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Grid_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Grid_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Grid_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Grid_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Grid_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Grid_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Grid_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Grid_generalized_affine_image_with_congruence(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Grid_generalized_affine_preimage_with_congruence(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Grid_generalized_affine_image_lhs_rhs_with_congruence(+term, +term, +term, +term, +term)).
:- foreign(ppl_Grid_generalized_affine_preimage_lhs_rhs_with_congruence(+term, +term, +term, +term, +term)).




:- foreign(ppl_Grid_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Grid_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Grid_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Grid_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Grid_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Grid_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Grid_map_space_dimensions(+term, +term)).



:- foreign(ppl_Grid_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Grid_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Grid_ascii_dump(+term)).



:- foreign(ppl_Grid_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Grid_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_Grid_congruence_widening_assign_with_tokens(+term, +term, +term, +term)).
:- foreign(ppl_Grid_generator_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Grid_congruence_widening_assign(+term, +term)).
:- foreign(ppl_Grid_generator_widening_assign(+term, +term)).




:- foreign(ppl_Grid_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_Grid_widening_assign(+term, +term)).



:- foreign(ppl_Grid_limited_congruence_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_Grid_limited_generator_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_Grid_limited_congruence_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_Grid_limited_generator_extrapolation_assign(+term, +term, +term)).









:- foreign(ppl_Grid_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_Grid(+term)).
:- foreign(ppl_termination_test_PR_Grid(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_Grid(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Grid(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Grid(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Grid(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Grid(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_Grid_2(+term, +term)).
:- foreign(ppl_termination_test_PR_Grid_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_Grid_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Grid_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Grid_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Grid_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Grid_2(+term, +term, +term, +term)).





:- foreign(ppl_delete_Rational_Box(+term)).



:- foreign(ppl_new_Rational_Box_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_Rational_Box_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_Grid(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_Double_Box(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_Rational_Box_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Rational_Box_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_Rational_Box_from_constraints(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_congruences(+term, +term)).
:- foreign(ppl_new_Rational_Box_from_generators(+term, +term)).





:- foreign(ppl_Rational_Box_swap(+term, +term)).



:- foreign(ppl_Rational_Box_space_dimension(+term, +term)).
:- foreign(ppl_Rational_Box_affine_dimension(+term, +term)).




:- foreign(ppl_Rational_Box_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Rational_Box_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Rational_Box_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_Rational_Box_get_constraints(+term, +term)).
:- foreign(ppl_Rational_Box_get_congruences(+term, +term)).




:- foreign(ppl_Rational_Box_get_minimized_constraints(+term, +term)).
:- foreign(ppl_Rational_Box_get_minimized_congruences(+term, +term)).




:- foreign(ppl_Rational_Box_is_empty(+term)).
:- foreign(ppl_Rational_Box_is_universe(+term)).
:- foreign(ppl_Rational_Box_is_bounded(+term)).
:- foreign(ppl_Rational_Box_contains_integer_point(+term)).
:- foreign(ppl_Rational_Box_is_topologically_closed(+term)).
:- foreign(ppl_Rational_Box_is_discrete(+term)).




:- foreign(ppl_Rational_Box_topological_closure_assign(+term)).




:- foreign(ppl_Rational_Box_bounds_from_above(+term, +term)).
:- foreign(ppl_Rational_Box_bounds_from_below(+term, +term)).




:- foreign(ppl_Rational_Box_has_upper_bound(+term, +term, +term, +term, +term)).
:- foreign(ppl_Rational_Box_has_lower_bound(+term, +term, +term, +term, +term)).




:- foreign(ppl_Rational_Box_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Rational_Box_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Rational_Box_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Rational_Box_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Rational_Box_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_Rational_Box_contains_Rational_Box(+term, +term)).
:- foreign(ppl_Rational_Box_strictly_contains_Rational_Box(+term, +term)).
:- foreign(ppl_Rational_Box_is_disjoint_from_Rational_Box(+term, +term)).




:- foreign(ppl_Rational_Box_equals_Rational_Box(+term, +term)).



:- foreign(ppl_Rational_Box_OK(+term)).



:- foreign(ppl_Rational_Box_add_constraint(+term, +term)).
:- foreign(ppl_Rational_Box_add_congruence(+term, +term)).




:- foreign(ppl_Rational_Box_add_constraints(+term, +term)).
:- foreign(ppl_Rational_Box_add_congruences(+term, +term)).




:- foreign(ppl_Rational_Box_refine_with_constraint(+term, +term)).
:- foreign(ppl_Rational_Box_refine_with_congruence(+term, +term)).




:- foreign(ppl_Rational_Box_refine_with_constraints(+term, +term)).
:- foreign(ppl_Rational_Box_refine_with_congruences(+term, +term)).




:- foreign(ppl_Rational_Box_intersection_assign(+term, +term)).
:- foreign(ppl_Rational_Box_upper_bound_assign(+term, +term)).
:- foreign(ppl_Rational_Box_difference_assign(+term, +term)).
:- foreign(ppl_Rational_Box_concatenate_assign(+term, +term)).
:- foreign(ppl_Rational_Box_time_elapse_assign(+term, +term)).




:- foreign(ppl_Rational_Box_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_Rational_Box_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_Rational_Box_constrains(+term, +term)).



:- foreign(ppl_Rational_Box_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Rational_Box_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Rational_Box_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Rational_Box_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Rational_Box_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Rational_Box_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Rational_Box_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Rational_Box_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Rational_Box_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Rational_Box_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Rational_Box_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Rational_Box_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Rational_Box_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Rational_Box_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Rational_Box_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Rational_Box_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Rational_Box_map_space_dimensions(+term, +term)).



:- foreign(ppl_Rational_Box_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Rational_Box_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Rational_Box_ascii_dump(+term)).



:- foreign(ppl_Rational_Box_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Rational_Box_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_Rational_Box_CC76_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Rational_Box_CC76_widening_assign(+term, +term)).




:- foreign(ppl_Rational_Box_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_Rational_Box_widening_assign(+term, +term)).



:- foreign(ppl_Rational_Box_limited_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_Rational_Box_limited_CC76_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_Rational_Box_CC76_narrowing_assign(+term, +term)).




:- foreign(ppl_Rational_Box_linear_partition(+term, +term, +term, +term)).




:- foreign(ppl_Rational_Box_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_Rational_Box(+term)).
:- foreign(ppl_termination_test_PR_Rational_Box(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_Rational_Box(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Rational_Box(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Rational_Box(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Rational_Box(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Rational_Box(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_Rational_Box_2(+term, +term)).
:- foreign(ppl_termination_test_PR_Rational_Box_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_Rational_Box_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Rational_Box_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Rational_Box_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Rational_Box_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Rational_Box_2(+term, +term, +term, +term)).





:- foreign(ppl_delete_BD_Shape_mpz_class(+term)).



:- foreign(ppl_new_BD_Shape_mpz_class_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_BD_Shape_mpz_class_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Grid(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Double_Box(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_BD_Shape_mpz_class_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_BD_Shape_mpz_class_from_constraints(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_congruences(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpz_class_from_generators(+term, +term)).





:- foreign(ppl_BD_Shape_mpz_class_swap(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_space_dimension(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_affine_dimension(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_get_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_get_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_get_minimized_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_get_minimized_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_is_empty(+term)).
:- foreign(ppl_BD_Shape_mpz_class_is_universe(+term)).
:- foreign(ppl_BD_Shape_mpz_class_is_bounded(+term)).
:- foreign(ppl_BD_Shape_mpz_class_contains_integer_point(+term)).
:- foreign(ppl_BD_Shape_mpz_class_is_topologically_closed(+term)).
:- foreign(ppl_BD_Shape_mpz_class_is_discrete(+term)).




:- foreign(ppl_BD_Shape_mpz_class_topological_closure_assign(+term)).




:- foreign(ppl_BD_Shape_mpz_class_bounds_from_above(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_bounds_from_below(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_contains_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_strictly_contains_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_is_disjoint_from_BD_Shape_mpz_class(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_equals_BD_Shape_mpz_class(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_OK(+term)).



:- foreign(ppl_BD_Shape_mpz_class_add_constraint(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_add_congruence(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_add_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_add_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_refine_with_constraint(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_refine_with_congruence(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_refine_with_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_refine_with_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_intersection_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_upper_bound_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_difference_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_concatenate_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_time_elapse_assign(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_constrains(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_remove_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_map_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_ascii_dump(+term)).



:- foreign(ppl_BD_Shape_mpz_class_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_BHMZ05_widening_assign_with_tokens(+term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_H79_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_BHMZ05_widening_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_H79_widening_assign(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_widening_assign(+term, +term)).



:- foreign(ppl_BD_Shape_mpz_class_limited_BHMZ05_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_limited_H79_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_limited_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_BD_Shape_mpz_class_limited_BHMZ05_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_limited_H79_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_BD_Shape_mpz_class_limited_CC76_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_BD_Shape_mpz_class_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_CC76_extrapolation_assign(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_CC76_narrowing_assign(+term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_linear_partition(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpz_class_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_BD_Shape_mpz_class(+term)).
:- foreign(ppl_termination_test_PR_BD_Shape_mpz_class(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_BD_Shape_mpz_class(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_BD_Shape_mpz_class(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_BD_Shape_mpz_class(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_BD_Shape_mpz_class_2(+term, +term)).
:- foreign(ppl_termination_test_PR_BD_Shape_mpz_class_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_BD_Shape_mpz_class_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_BD_Shape_mpz_class_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_BD_Shape_mpz_class_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_BD_Shape_mpz_class_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_BD_Shape_mpz_class_2(+term, +term, +term, +term)).





:- foreign(ppl_delete_BD_Shape_mpq_class(+term)).



:- foreign(ppl_new_BD_Shape_mpq_class_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_BD_Shape_mpq_class_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Grid(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Double_Box(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_BD_Shape_mpq_class_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_BD_Shape_mpq_class_from_constraints(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_congruences(+term, +term)).
:- foreign(ppl_new_BD_Shape_mpq_class_from_generators(+term, +term)).





:- foreign(ppl_BD_Shape_mpq_class_swap(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_space_dimension(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_affine_dimension(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_get_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_get_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_get_minimized_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_get_minimized_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_is_empty(+term)).
:- foreign(ppl_BD_Shape_mpq_class_is_universe(+term)).
:- foreign(ppl_BD_Shape_mpq_class_is_bounded(+term)).
:- foreign(ppl_BD_Shape_mpq_class_contains_integer_point(+term)).
:- foreign(ppl_BD_Shape_mpq_class_is_topologically_closed(+term)).
:- foreign(ppl_BD_Shape_mpq_class_is_discrete(+term)).




:- foreign(ppl_BD_Shape_mpq_class_topological_closure_assign(+term)).




:- foreign(ppl_BD_Shape_mpq_class_bounds_from_above(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_bounds_from_below(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_contains_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_strictly_contains_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_is_disjoint_from_BD_Shape_mpq_class(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_equals_BD_Shape_mpq_class(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_OK(+term)).



:- foreign(ppl_BD_Shape_mpq_class_add_constraint(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_add_congruence(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_add_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_add_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_refine_with_constraint(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_refine_with_congruence(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_refine_with_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_refine_with_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_intersection_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_upper_bound_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_difference_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_concatenate_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_time_elapse_assign(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_constrains(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_remove_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_map_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_ascii_dump(+term)).



:- foreign(ppl_BD_Shape_mpq_class_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_BHMZ05_widening_assign_with_tokens(+term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_H79_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_BHMZ05_widening_assign(+term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_H79_widening_assign(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_widening_assign(+term, +term)).



:- foreign(ppl_BD_Shape_mpq_class_limited_BHMZ05_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_limited_H79_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_limited_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_BD_Shape_mpq_class_limited_BHMZ05_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_limited_H79_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_BD_Shape_mpq_class_limited_CC76_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_BD_Shape_mpq_class_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_CC76_extrapolation_assign(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_CC76_narrowing_assign(+term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_linear_partition(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_mpq_class_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_BD_Shape_mpq_class(+term)).
:- foreign(ppl_termination_test_PR_BD_Shape_mpq_class(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_BD_Shape_mpq_class(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_BD_Shape_mpq_class(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_BD_Shape_mpq_class(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_BD_Shape_mpq_class_2(+term, +term)).
:- foreign(ppl_termination_test_PR_BD_Shape_mpq_class_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_BD_Shape_mpq_class_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_BD_Shape_mpq_class_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_BD_Shape_mpq_class_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_BD_Shape_mpq_class_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_BD_Shape_mpq_class_2(+term, +term, +term, +term)).





:- foreign(ppl_delete_Octagonal_Shape_mpz_class(+term)).



:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Grid(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Double_Box(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_constraints(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_congruences(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpz_class_from_generators(+term, +term)).





:- foreign(ppl_Octagonal_Shape_mpz_class_swap(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_space_dimension(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_affine_dimension(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_get_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_get_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_get_minimized_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_get_minimized_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_is_empty(+term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_is_universe(+term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_is_bounded(+term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_contains_integer_point(+term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_is_topologically_closed(+term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_is_discrete(+term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_topological_closure_assign(+term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_bounds_from_above(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_bounds_from_below(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_contains_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_strictly_contains_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_is_disjoint_from_Octagonal_Shape_mpz_class(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_equals_Octagonal_Shape_mpz_class(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_OK(+term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_add_constraint(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_add_congruence(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_add_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_add_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_refine_with_constraint(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_refine_with_congruence(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_refine_with_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_refine_with_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_intersection_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_upper_bound_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_difference_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_concatenate_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_time_elapse_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_constrains(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_map_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_ascii_dump(+term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_BHMZ05_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_BHMZ05_widening_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_widening_assign(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpz_class_limited_BHMZ05_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_limited_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_Octagonal_Shape_mpz_class_limited_BHMZ05_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpz_class_limited_CC76_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_Octagonal_Shape_mpz_class_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_CC76_extrapolation_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_CC76_narrowing_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_linear_partition(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpz_class_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_Octagonal_Shape_mpz_class(+term)).
:- foreign(ppl_termination_test_PR_Octagonal_Shape_mpz_class(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Octagonal_Shape_mpz_class(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Octagonal_Shape_mpz_class(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Octagonal_Shape_mpz_class(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_Octagonal_Shape_mpz_class_2(+term, +term)).
:- foreign(ppl_termination_test_PR_Octagonal_Shape_mpz_class_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_Octagonal_Shape_mpz_class_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Octagonal_Shape_mpz_class_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Octagonal_Shape_mpz_class_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Octagonal_Shape_mpz_class_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Octagonal_Shape_mpz_class_2(+term, +term, +term, +term)).





:- foreign(ppl_delete_Octagonal_Shape_mpq_class(+term)).



:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Grid(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Double_Box(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_constraints(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_congruences(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_mpq_class_from_generators(+term, +term)).





:- foreign(ppl_Octagonal_Shape_mpq_class_swap(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_space_dimension(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_affine_dimension(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_get_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_get_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_get_minimized_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_get_minimized_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_is_empty(+term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_is_universe(+term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_is_bounded(+term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_contains_integer_point(+term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_is_topologically_closed(+term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_is_discrete(+term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_topological_closure_assign(+term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_bounds_from_above(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_bounds_from_below(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_contains_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_strictly_contains_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_is_disjoint_from_Octagonal_Shape_mpq_class(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_equals_Octagonal_Shape_mpq_class(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_OK(+term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_add_constraint(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_add_congruence(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_add_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_add_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_refine_with_constraint(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_refine_with_congruence(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_refine_with_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_refine_with_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_intersection_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_upper_bound_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_difference_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_concatenate_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_time_elapse_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_constrains(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_map_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_ascii_dump(+term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_BHMZ05_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_BHMZ05_widening_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_widening_assign(+term, +term)).



:- foreign(ppl_Octagonal_Shape_mpq_class_limited_BHMZ05_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_limited_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_Octagonal_Shape_mpq_class_limited_BHMZ05_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_mpq_class_limited_CC76_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_Octagonal_Shape_mpq_class_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_CC76_extrapolation_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_CC76_narrowing_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_linear_partition(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_mpq_class_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_Octagonal_Shape_mpq_class(+term)).
:- foreign(ppl_termination_test_PR_Octagonal_Shape_mpq_class(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Octagonal_Shape_mpq_class(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Octagonal_Shape_mpq_class(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Octagonal_Shape_mpq_class(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_Octagonal_Shape_mpq_class_2(+term, +term)).
:- foreign(ppl_termination_test_PR_Octagonal_Shape_mpq_class_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_Octagonal_Shape_mpq_class_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Octagonal_Shape_mpq_class_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Octagonal_Shape_mpq_class_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Octagonal_Shape_mpq_class_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Octagonal_Shape_mpq_class_2(+term, +term, +term, +term)).





:- foreign(ppl_delete_Constraints_Product_C_Polyhedron_Grid(+term)).



:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Grid(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Double_Box(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Octagonal_Shape_double(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Constraints_Product_C_Polyhedron_Grid(+term, +term)).





:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_Constraints_Product_C_Polyhedron_Grid_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_constraints(+term, +term)).
:- foreign(ppl_new_Constraints_Product_C_Polyhedron_Grid_from_congruences(+term, +term)).





:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_swap(+term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_space_dimension(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_affine_dimension(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_is_empty(+term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_is_universe(+term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_is_bounded(+term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_is_topologically_closed(+term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_is_discrete(+term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_topological_closure_assign(+term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_bounds_from_above(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_bounds_from_below(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_contains_Constraints_Product_C_Polyhedron_Grid(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_strictly_contains_Constraints_Product_C_Polyhedron_Grid(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_is_disjoint_from_Constraints_Product_C_Polyhedron_Grid(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_equals_Constraints_Product_C_Polyhedron_Grid(+term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_OK(+term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_add_constraint(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_add_congruence(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_add_constraints(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_add_congruences(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_refine_with_constraint(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_refine_with_congruence(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_refine_with_constraints(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_refine_with_congruences(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_intersection_assign(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_upper_bound_assign(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_difference_assign(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_concatenate_assign(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_time_elapse_assign(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_constrains(+term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_map_space_dimensions(+term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_ascii_dump(+term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_Constraints_Product_C_Polyhedron_Grid_widening_assign(+term, +term)).




:- foreign(ppl_delete_Pointset_Powerset_C_Polyhedron(+term)).



:- foreign(ppl_new_Pointset_Powerset_C_Polyhedron_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_Pointset_Powerset_C_Polyhedron_from_Pointset_Powerset_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_Pointset_Powerset_C_Polyhedron_from_C_Polyhedron(+term, +term)).





:- foreign(ppl_new_Pointset_Powerset_C_Polyhedron_from_Pointset_Powerset_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Pointset_Powerset_C_Polyhedron_from_C_Polyhedron_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_Pointset_Powerset_C_Polyhedron_from_constraints(+term, +term)).
:- foreign(ppl_new_Pointset_Powerset_C_Polyhedron_from_congruences(+term, +term)).





:- foreign(ppl_Pointset_Powerset_C_Polyhedron_swap(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_space_dimension(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_affine_dimension(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_is_empty(+term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_is_universe(+term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_is_bounded(+term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_contains_integer_point(+term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_is_topologically_closed(+term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_is_discrete(+term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_topological_closure_assign(+term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_pairwise_reduce(+term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_omega_reduce(+term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_bounds_from_above(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_bounds_from_below(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_contains_Pointset_Powerset_C_Polyhedron(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_strictly_contains_Pointset_Powerset_C_Polyhedron(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_is_disjoint_from_Pointset_Powerset_C_Polyhedron(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_geometrically_covers_Pointset_Powerset_C_Polyhedron(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_geometrically_equals_Pointset_Powerset_C_Polyhedron(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_equals_Pointset_Powerset_C_Polyhedron(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_OK(+term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_add_constraint(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_add_congruence(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_add_constraints(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_add_congruences(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_refine_with_constraint(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_refine_with_congruence(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_refine_with_constraints(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_refine_with_congruences(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_intersection_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_upper_bound_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_difference_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_concatenate_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_time_elapse_assign(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_constrains(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_map_space_dimensions(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_ascii_dump(+term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_total_memory_in_bytes(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_size(+term, +term)).




:- foreign(ppl_new_Pointset_Powerset_C_Polyhedron_iterator_from_iterator(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_begin_iterator(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_end_iterator(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_iterator_equals_iterator(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_increment_iterator(+term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_decrement_iterator(+term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_get_disjunct(+term, +term)).



:- foreign(ppl_delete_Pointset_Powerset_C_Polyhedron_iterator(+term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_add_disjunct(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_drop_disjunct(+term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_drop_disjuncts(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_C_Polyhedron_BHZ03_BHRZ03_BHRZ03_widening_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_BHZ03_H79_H79_widening_assign(+term, +term)).




:- foreign(ppl_Pointset_Powerset_C_Polyhedron_BGP99_BHRZ03_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_C_Polyhedron_BGP99_H79_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_delete_Pointset_Powerset_NNC_Polyhedron(+term)).



:- foreign(ppl_new_Pointset_Powerset_NNC_Polyhedron_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_Pointset_Powerset_NNC_Polyhedron_from_Pointset_Powerset_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_Pointset_Powerset_NNC_Polyhedron_from_NNC_Polyhedron(+term, +term)).





:- foreign(ppl_new_Pointset_Powerset_NNC_Polyhedron_from_Pointset_Powerset_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Pointset_Powerset_NNC_Polyhedron_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_Pointset_Powerset_NNC_Polyhedron_from_constraints(+term, +term)).
:- foreign(ppl_new_Pointset_Powerset_NNC_Polyhedron_from_congruences(+term, +term)).





:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_swap(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_space_dimension(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_affine_dimension(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_is_empty(+term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_is_universe(+term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_is_bounded(+term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_contains_integer_point(+term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_is_topologically_closed(+term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_is_discrete(+term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_topological_closure_assign(+term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_pairwise_reduce(+term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_omega_reduce(+term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_bounds_from_above(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_bounds_from_below(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_contains_Pointset_Powerset_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_strictly_contains_Pointset_Powerset_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_is_disjoint_from_Pointset_Powerset_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_geometrically_covers_Pointset_Powerset_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_geometrically_equals_Pointset_Powerset_NNC_Polyhedron(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_equals_Pointset_Powerset_NNC_Polyhedron(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_OK(+term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_add_constraint(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_add_congruence(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_add_constraints(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_add_congruences(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_refine_with_constraint(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_refine_with_congruence(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_refine_with_constraints(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_refine_with_congruences(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_intersection_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_upper_bound_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_difference_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_concatenate_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_time_elapse_assign(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_constrains(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_map_space_dimensions(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_ascii_dump(+term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_total_memory_in_bytes(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_size(+term, +term)).




:- foreign(ppl_new_Pointset_Powerset_NNC_Polyhedron_iterator_from_iterator(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_begin_iterator(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_end_iterator(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_iterator_equals_iterator(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_increment_iterator(+term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_decrement_iterator(+term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_get_disjunct(+term, +term)).



:- foreign(ppl_delete_Pointset_Powerset_NNC_Polyhedron_iterator(+term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_add_disjunct(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_drop_disjunct(+term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_drop_disjuncts(+term, +term, +term)).



:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_BHZ03_BHRZ03_BHRZ03_widening_assign(+term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_BHZ03_H79_H79_widening_assign(+term, +term)).




:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_BGP99_BHRZ03_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_Pointset_Powerset_NNC_Polyhedron_BGP99_H79_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_delete_Double_Box(+term)).



:- foreign(ppl_new_Double_Box_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_Double_Box_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_Double_Box_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_Double_Box_from_Grid(+term, +term)).
:- foreign(ppl_new_Double_Box_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_Double_Box_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Double_Box_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Double_Box_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Double_Box_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Double_Box_from_Double_Box(+term, +term)).
:- foreign(ppl_new_Double_Box_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_Double_Box_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_Double_Box_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Double_Box_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_Double_Box_from_constraints(+term, +term)).
:- foreign(ppl_new_Double_Box_from_congruences(+term, +term)).
:- foreign(ppl_new_Double_Box_from_generators(+term, +term)).





:- foreign(ppl_Double_Box_swap(+term, +term)).



:- foreign(ppl_Double_Box_space_dimension(+term, +term)).
:- foreign(ppl_Double_Box_affine_dimension(+term, +term)).




:- foreign(ppl_Double_Box_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Double_Box_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Double_Box_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_Double_Box_get_constraints(+term, +term)).
:- foreign(ppl_Double_Box_get_congruences(+term, +term)).




:- foreign(ppl_Double_Box_get_minimized_constraints(+term, +term)).
:- foreign(ppl_Double_Box_get_minimized_congruences(+term, +term)).




:- foreign(ppl_Double_Box_is_empty(+term)).
:- foreign(ppl_Double_Box_is_universe(+term)).
:- foreign(ppl_Double_Box_is_bounded(+term)).
:- foreign(ppl_Double_Box_contains_integer_point(+term)).
:- foreign(ppl_Double_Box_is_topologically_closed(+term)).
:- foreign(ppl_Double_Box_is_discrete(+term)).




:- foreign(ppl_Double_Box_topological_closure_assign(+term)).




:- foreign(ppl_Double_Box_bounds_from_above(+term, +term)).
:- foreign(ppl_Double_Box_bounds_from_below(+term, +term)).




:- foreign(ppl_Double_Box_has_upper_bound(+term, +term, +term, +term, +term)).
:- foreign(ppl_Double_Box_has_lower_bound(+term, +term, +term, +term, +term)).




:- foreign(ppl_Double_Box_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Double_Box_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Double_Box_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Double_Box_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Double_Box_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_Double_Box_contains_Double_Box(+term, +term)).
:- foreign(ppl_Double_Box_strictly_contains_Double_Box(+term, +term)).
:- foreign(ppl_Double_Box_is_disjoint_from_Double_Box(+term, +term)).




:- foreign(ppl_Double_Box_equals_Double_Box(+term, +term)).



:- foreign(ppl_Double_Box_OK(+term)).



:- foreign(ppl_Double_Box_add_constraint(+term, +term)).
:- foreign(ppl_Double_Box_add_congruence(+term, +term)).




:- foreign(ppl_Double_Box_add_constraints(+term, +term)).
:- foreign(ppl_Double_Box_add_congruences(+term, +term)).




:- foreign(ppl_Double_Box_refine_with_constraint(+term, +term)).
:- foreign(ppl_Double_Box_refine_with_congruence(+term, +term)).




:- foreign(ppl_Double_Box_refine_with_constraints(+term, +term)).
:- foreign(ppl_Double_Box_refine_with_congruences(+term, +term)).




:- foreign(ppl_Double_Box_intersection_assign(+term, +term)).
:- foreign(ppl_Double_Box_upper_bound_assign(+term, +term)).
:- foreign(ppl_Double_Box_difference_assign(+term, +term)).
:- foreign(ppl_Double_Box_concatenate_assign(+term, +term)).
:- foreign(ppl_Double_Box_time_elapse_assign(+term, +term)).




:- foreign(ppl_Double_Box_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_Double_Box_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_Double_Box_constrains(+term, +term)).



:- foreign(ppl_Double_Box_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Double_Box_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Double_Box_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Double_Box_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Double_Box_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Double_Box_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Double_Box_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Double_Box_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Double_Box_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Double_Box_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Double_Box_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Double_Box_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Double_Box_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Double_Box_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Double_Box_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Double_Box_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Double_Box_map_space_dimensions(+term, +term)).



:- foreign(ppl_Double_Box_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Double_Box_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Double_Box_ascii_dump(+term)).



:- foreign(ppl_Double_Box_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Double_Box_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_Double_Box_CC76_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Double_Box_CC76_widening_assign(+term, +term)).




:- foreign(ppl_Double_Box_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_Double_Box_widening_assign(+term, +term)).



:- foreign(ppl_Double_Box_limited_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_Double_Box_limited_CC76_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_Double_Box_CC76_narrowing_assign(+term, +term)).




:- foreign(ppl_Double_Box_linear_partition(+term, +term, +term, +term)).




:- foreign(ppl_Double_Box_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_Double_Box(+term)).
:- foreign(ppl_termination_test_PR_Double_Box(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_Double_Box(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Double_Box(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Double_Box(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Double_Box(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Double_Box(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_Double_Box_2(+term, +term)).
:- foreign(ppl_termination_test_PR_Double_Box_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_Double_Box_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Double_Box_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Double_Box_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Double_Box_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Double_Box_2(+term, +term, +term, +term)).





:- foreign(ppl_delete_BD_Shape_double(+term)).



:- foreign(ppl_new_BD_Shape_double_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_BD_Shape_double_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Grid(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Double_Box(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_BD_Shape_double_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_BD_Shape_double_from_constraints(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_congruences(+term, +term)).
:- foreign(ppl_new_BD_Shape_double_from_generators(+term, +term)).





:- foreign(ppl_BD_Shape_double_swap(+term, +term)).



:- foreign(ppl_BD_Shape_double_space_dimension(+term, +term)).
:- foreign(ppl_BD_Shape_double_affine_dimension(+term, +term)).




:- foreign(ppl_BD_Shape_double_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_BD_Shape_double_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_BD_Shape_double_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_BD_Shape_double_get_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_double_get_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_double_get_minimized_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_double_get_minimized_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_double_is_empty(+term)).
:- foreign(ppl_BD_Shape_double_is_universe(+term)).
:- foreign(ppl_BD_Shape_double_is_bounded(+term)).
:- foreign(ppl_BD_Shape_double_contains_integer_point(+term)).
:- foreign(ppl_BD_Shape_double_is_topologically_closed(+term)).
:- foreign(ppl_BD_Shape_double_is_discrete(+term)).




:- foreign(ppl_BD_Shape_double_topological_closure_assign(+term)).




:- foreign(ppl_BD_Shape_double_bounds_from_above(+term, +term)).
:- foreign(ppl_BD_Shape_double_bounds_from_below(+term, +term)).




:- foreign(ppl_BD_Shape_double_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_double_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_double_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_double_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_double_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_BD_Shape_double_contains_BD_Shape_double(+term, +term)).
:- foreign(ppl_BD_Shape_double_strictly_contains_BD_Shape_double(+term, +term)).
:- foreign(ppl_BD_Shape_double_is_disjoint_from_BD_Shape_double(+term, +term)).




:- foreign(ppl_BD_Shape_double_equals_BD_Shape_double(+term, +term)).



:- foreign(ppl_BD_Shape_double_OK(+term)).



:- foreign(ppl_BD_Shape_double_add_constraint(+term, +term)).
:- foreign(ppl_BD_Shape_double_add_congruence(+term, +term)).




:- foreign(ppl_BD_Shape_double_add_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_double_add_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_double_refine_with_constraint(+term, +term)).
:- foreign(ppl_BD_Shape_double_refine_with_congruence(+term, +term)).




:- foreign(ppl_BD_Shape_double_refine_with_constraints(+term, +term)).
:- foreign(ppl_BD_Shape_double_refine_with_congruences(+term, +term)).




:- foreign(ppl_BD_Shape_double_intersection_assign(+term, +term)).
:- foreign(ppl_BD_Shape_double_upper_bound_assign(+term, +term)).
:- foreign(ppl_BD_Shape_double_difference_assign(+term, +term)).
:- foreign(ppl_BD_Shape_double_concatenate_assign(+term, +term)).
:- foreign(ppl_BD_Shape_double_time_elapse_assign(+term, +term)).




:- foreign(ppl_BD_Shape_double_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_BD_Shape_double_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_BD_Shape_double_constrains(+term, +term)).



:- foreign(ppl_BD_Shape_double_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_BD_Shape_double_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_double_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_double_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_double_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_double_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_double_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_double_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_double_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_double_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_double_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_BD_Shape_double_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_BD_Shape_double_remove_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_double_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_double_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_BD_Shape_double_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_BD_Shape_double_map_space_dimensions(+term, +term)).



:- foreign(ppl_BD_Shape_double_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_BD_Shape_double_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_BD_Shape_double_ascii_dump(+term)).



:- foreign(ppl_BD_Shape_double_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_BD_Shape_double_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_BD_Shape_double_BHMZ05_widening_assign_with_tokens(+term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_double_H79_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_double_BHMZ05_widening_assign(+term, +term)).
:- foreign(ppl_BD_Shape_double_H79_widening_assign(+term, +term)).




:- foreign(ppl_BD_Shape_double_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_BD_Shape_double_widening_assign(+term, +term)).



:- foreign(ppl_BD_Shape_double_limited_BHMZ05_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_double_limited_H79_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_BD_Shape_double_limited_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_BD_Shape_double_limited_BHMZ05_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_BD_Shape_double_limited_H79_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_BD_Shape_double_limited_CC76_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_BD_Shape_double_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_double_CC76_extrapolation_assign(+term, +term)).




:- foreign(ppl_BD_Shape_double_CC76_narrowing_assign(+term, +term)).




:- foreign(ppl_BD_Shape_double_linear_partition(+term, +term, +term, +term)).




:- foreign(ppl_BD_Shape_double_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_BD_Shape_double(+term)).
:- foreign(ppl_termination_test_PR_BD_Shape_double(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_BD_Shape_double(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_BD_Shape_double(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_BD_Shape_double(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_BD_Shape_double(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_BD_Shape_double(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_BD_Shape_double_2(+term, +term)).
:- foreign(ppl_termination_test_PR_BD_Shape_double_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_BD_Shape_double_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_BD_Shape_double_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_BD_Shape_double_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_BD_Shape_double_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_BD_Shape_double_2(+term, +term, +term, +term)).





:- foreign(ppl_delete_Octagonal_Shape_double(+term)).



:- foreign(ppl_new_Octagonal_Shape_double_from_space_dimension(+term, +term, +term)).




:- foreign(ppl_new_Octagonal_Shape_double_from_C_Polyhedron(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_NNC_Polyhedron(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Grid(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Rational_Box(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_BD_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_BD_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Octagonal_Shape_mpz_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Octagonal_Shape_mpq_class(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Double_Box(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_BD_Shape_double(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_new_Octagonal_Shape_double_from_C_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_NNC_Polyhedron_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Grid_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Rational_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_BD_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_BD_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Octagonal_Shape_mpz_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Octagonal_Shape_mpq_class_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Double_Box_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_BD_Shape_double_with_complexity(+term, +term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_Octagonal_Shape_double_with_complexity(+term, +term, +term)).





:- foreign(ppl_new_Octagonal_Shape_double_from_constraints(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_congruences(+term, +term)).
:- foreign(ppl_new_Octagonal_Shape_double_from_generators(+term, +term)).





:- foreign(ppl_Octagonal_Shape_double_swap(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_space_dimension(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_affine_dimension(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_relation_with_constraint(+term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_relation_with_generator(+term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_relation_with_congruence(+term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_get_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_get_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_get_minimized_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_get_minimized_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_is_empty(+term)).
:- foreign(ppl_Octagonal_Shape_double_is_universe(+term)).
:- foreign(ppl_Octagonal_Shape_double_is_bounded(+term)).
:- foreign(ppl_Octagonal_Shape_double_contains_integer_point(+term)).
:- foreign(ppl_Octagonal_Shape_double_is_topologically_closed(+term)).
:- foreign(ppl_Octagonal_Shape_double_is_discrete(+term)).




:- foreign(ppl_Octagonal_Shape_double_topological_closure_assign(+term)).




:- foreign(ppl_Octagonal_Shape_double_bounds_from_above(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_bounds_from_below(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_maximize(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_minimize(+term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_maximize_with_point(+term, +term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_minimize_with_point(+term, +term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_frequency(+term, +term, +term, +term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_double_contains_Octagonal_Shape_double(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_strictly_contains_Octagonal_Shape_double(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_is_disjoint_from_Octagonal_Shape_double(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_equals_Octagonal_Shape_double(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_OK(+term)).



:- foreign(ppl_Octagonal_Shape_double_add_constraint(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_add_congruence(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_add_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_add_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_refine_with_constraint(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_refine_with_congruence(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_refine_with_constraints(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_refine_with_congruences(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_intersection_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_upper_bound_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_difference_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_concatenate_assign(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_time_elapse_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_upper_bound_assign_if_exact(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_simplify_using_context_assign(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_double_constrains(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_unconstrain_space_dimension(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_unconstrain_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_affine_image(+term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_affine_preimage(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_bounded_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_bounded_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_generalized_affine_image(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_generalized_affine_preimage(+term, +term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_generalized_affine_image_lhs_rhs(+term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_generalized_affine_preimage_lhs_rhs(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_add_space_dimensions_and_embed(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_add_space_dimensions_and_project(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_remove_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_remove_higher_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_expand_space_dimension(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_double_fold_space_dimensions(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_double_map_space_dimensions(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_drop_some_non_integer_points(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_drop_some_non_integer_points_2(+term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_double_ascii_dump(+term)).



:- foreign(ppl_Octagonal_Shape_double_external_memory_in_bytes(+term, +term)).
:- foreign(ppl_Octagonal_Shape_double_total_memory_in_bytes(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_BHMZ05_widening_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_BHMZ05_widening_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_widening_assign_with_tokens(+term, +term, +term, +term)).



:- foreign(ppl_Octagonal_Shape_double_widening_assign(+term, +term)).



:- foreign(ppl_Octagonal_Shape_double_limited_BHMZ05_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_limited_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term, +term)).





:- foreign(ppl_Octagonal_Shape_double_limited_BHMZ05_extrapolation_assign(+term, +term, +term)).
:- foreign(ppl_Octagonal_Shape_double_limited_CC76_extrapolation_assign(+term, +term, +term)).





:- foreign(ppl_Octagonal_Shape_double_CC76_extrapolation_assign_with_tokens(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_CC76_extrapolation_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_CC76_narrowing_assign(+term, +term)).




:- foreign(ppl_Octagonal_Shape_double_linear_partition(+term, +term, +term, +term)).




:- foreign(ppl_Octagonal_Shape_double_wrap_assign(+term, +term, +term, +term, +term, +term, +term, +term)).



:- foreign(ppl_termination_test_MS_Octagonal_Shape_double(+term)).
:- foreign(ppl_termination_test_PR_Octagonal_Shape_double(+term)).





:- foreign(ppl_one_affine_ranking_function_MS_Octagonal_Shape_double(+term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Octagonal_Shape_double(+term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Octagonal_Shape_double(+term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Octagonal_Shape_double(+term, +term, +term)).




:- foreign(ppl_termination_test_MS_Octagonal_Shape_double_2(+term, +term)).
:- foreign(ppl_termination_test_PR_Octagonal_Shape_double_2(+term, +term)).





:- foreign(ppl_one_affine_ranking_function_MS_Octagonal_Shape_double_2(+term, +term, +term)).
:- foreign(ppl_one_affine_ranking_function_PR_Octagonal_Shape_double_2(+term, +term, +term)).





:- foreign(ppl_all_affine_ranking_functions_MS_Octagonal_Shape_double_2(+term, +term, +term)).
:- foreign(ppl_all_affine_ranking_functions_PR_Octagonal_Shape_double_2(+term, +term, +term)).





:- foreign(ppl_all_affine_quasi_ranking_functions_MS_Octagonal_Shape_double_2(+term, +term, +term, +term)).





